diff --git a/src/include/storage/buf_internals.h b/src/include/storage/buf_internals.h
index 60111fb..6cd7a3a 100644
--- a/src/include/storage/buf_internals.h
+++ b/src/include/storage/buf_internals.h
@@ -17,8 +17,9 @@
 
 #include "storage/backendid.h"
 #include "storage/buf.h"
-#include "storage/lmgr.h"
 #include "storage/lwlock.h"
+#include "storage/shmem.h"
+#include "utils/rel.h"
 
 
 /*
@@ -40,10 +41,10 @@ typedef bits16 BufFlags;
  * Buffer tag identifies which disk block the buffer contains.
  *
  * Note: the BufferTag data must be sufficient to determine where to write the
- * block, even during a "blind write" with no relcache entry.  It's possible
- * that the backend flushing the buffer doesn't even believe the relation is
- * visible yet (its xact may have started before the xact that created the
- * rel).  The storage manager must be able to cope anyway.
+ * block, without reference to pg_class or pg_tablespace entries.  It's
+ * possible that the backend flushing the buffer doesn't even believe the
+ * relation is visible yet (its xact may have started before the xact that
+ * created the rel).  The storage manager must be able to cope anyway.
  *
  * Note: if there's any pad bytes in the struct, INIT_BUFFERTAG will have
  * to be fixed to zero them, since this struct is used as a hash key.
@@ -107,58 +108,12 @@ typedef struct sbufdesc
 
 #define BufferDescriptorGetBuffer(bdesc) ((bdesc)->buf_id + 1)
 
-/* entry for buffer lookup hashtable */
-typedef struct
-{
-	BufferTag	key;			/* Tag of a disk page */
-	int			id;				/* CDB id of associated CDB */
-} BufferLookupEnt;
-
-/*
- * Definitions for the buffer replacement strategy
- */
-#define STRAT_LIST_UNUSED	(-1)
-#define STRAT_LIST_B1		0
-#define STRAT_LIST_T1		1
-#define STRAT_LIST_T2		2
-#define STRAT_LIST_B2		3
-#define STRAT_NUM_LISTS		4
-
-/*
- * The Cache Directory Block (CDB) of the Adaptive Replacement Cache (ARC)
- */
-typedef struct
-{
-	int			prev;			/* list links */
-	int			next;
-	short		list;			/* ID of list it is currently in */
-	bool		t1_vacuum;		/* t => present only because of VACUUM */
-	TransactionId t1_xid;		/* the xid this entry went onto T1 */
-	BufferTag	buf_tag;		/* page identifier */
-	int			buf_id;			/* currently assigned data buffer, or -1 */
-} BufferStrategyCDB;
-
-/*
- * The shared ARC control information.
- */
-typedef struct
-{
-	int			target_T1_size; /* What T1 size are we aiming for */
-	int			listUnusedCDB;	/* All unused StrategyCDB */
-	int			listHead[STRAT_NUM_LISTS];		/* ARC lists B1, T1, T2
-												 * and B2 */
-	int			listTail[STRAT_NUM_LISTS];
-	int			listSize[STRAT_NUM_LISTS];
-	Buffer		listFreeBuffers;	/* List of unused buffers */
-
-	long		num_lookup;		/* Some hit statistics */
-	long		num_hit[STRAT_NUM_LISTS];
-	time_t		stat_report;
 
-	/* Array of CDB's starts here */
-	BufferStrategyCDB cdb[1];	/* VARIABLE SIZE ARRAY */
-} BufferStrategyControl;
+/* in bufmgr.c */
+extern BufferDesc *BufferDescriptors;
 
+/* in localbuf.c */
+extern BufferDesc *LocalBufferDescriptors;
 
 /* counters in buf_init.c */
 extern long int ReadBufferCount;
@@ -170,11 +125,9 @@ extern long int LocalBufferFlushCount;
 
 
 /*
- * Bufmgr Interface:
+ * Internal routines: only called by bufmgr
  */
 
-/* Internal routines: only called by bufmgr */
-
 /* freelist.c */
 extern BufferDesc *StrategyBufferLookup(BufferTag *tagPtr, bool recheck,
 					 int *cdb_found_index);
@@ -185,20 +138,17 @@ extern void StrategyInvalidateBuffer(BufferDesc *buf);
 extern void StrategyHintVacuum(bool vacuum_active);
 extern int StrategyDirtyBufferList(BufferDesc **buffers, BufferTag *buftags,
 						int max_buffers);
+extern int	StrategyShmemSize(void);
 extern void StrategyInitialize(bool init);
 
 /* buf_table.c */
+extern int	BufTableShmemSize(int size);
 extern void InitBufTable(int size);
 extern int	BufTableLookup(BufferTag *tagPtr);
-extern void BufTableInsert(BufferTag *tagPtr, int cdb_id);
+extern void BufTableInsert(BufferTag *tagPtr, int buf_id);
 extern void BufTableDelete(BufferTag *tagPtr);
 
-/* bufmgr.c */
-extern BufferDesc *BufferDescriptors;
-
 /* localbuf.c */
-extern BufferDesc *LocalBufferDescriptors;
-
 extern BufferDesc *LocalBufferAlloc(Relation reln, BlockNumber blockNum,
 				 bool *foundPtr);
 extern void WriteLocalBuffer(Buffer buffer, bool release);
diff --git a/src/include/storage/bufmgr.h b/src/include/storage/bufmgr.h
index f8fbd8f..a04ec3d 100644
--- a/src/include/storage/bufmgr.h
+++ b/src/include/storage/bufmgr.h
@@ -153,5 +153,6 @@ extern void BufmgrCommit(void);
 extern int	BufferSync(int percent, int maxpages);
 
 extern void InitLocalBuffer(void);
+extern void AtProcExit_LocalBuffers(void);
 
 #endif
diff --git a/src/include/tcop/tcopprot.h b/src/include/tcop/tcopprot.h
index 14660cc..7248cc7 100644
--- a/src/include/tcop/tcopprot.h
+++ b/src/include/tcop/tcopprot.h
@@ -59,6 +59,8 @@ extern bool assign_max_stack_depth(int newval, bool doit, GucSource source);
 extern void die(SIGNAL_ARGS);
 extern void quickdie(SIGNAL_ARGS);
 extern void authdie(SIGNAL_ARGS);
+extern void prepare_for_client_read(void);
+extern void client_read_ended(void);
 extern int	PostgresMain(int argc, char *argv[], const char *username);
 extern void ResetUsage(void);
 extern void ShowUsage(const char *title);
diff --git a/src/include/utils/array.h b/src/include/utils/array.h
index 22c8a47..a0fba03 100644
--- a/src/include/utils/array.h
+++ b/src/include/utils/array.h
@@ -65,6 +65,15 @@ typedef struct ArrayMetaState
 } ArrayMetaState;
 
 /*
+ * private state needed by array_map (here because caller must provide it)
+ */
+typedef struct ArrayMapState
+{
+	ArrayMetaState inp_extra;
+	ArrayMetaState ret_extra;
+} ArrayMapState;
+
+/*
  * fmgr macros for array objects
  */
 #define DatumGetArrayTypeP(X)		  ((ArrayType *) PG_DETOAST_DATUM(X))
@@ -147,7 +156,8 @@ extern ArrayType *array_set_slice(ArrayType *array, int nSubscripts,
 				int arraylen, int elmlen, bool elmbyval, char elmalign,
 				bool *isNull);
 
-extern Datum array_map(FunctionCallInfo fcinfo, Oid inpType, Oid retType);
+extern Datum array_map(FunctionCallInfo fcinfo, Oid inpType, Oid retType,
+					   ArrayMapState *amstate);
 
 extern ArrayType *construct_array(Datum *elems, int nelems,
 				Oid elmtype,
diff --git a/src/include/utils/datetime.h b/src/include/utils/datetime.h
index d279fd3..2f2dd21 100644
--- a/src/include/utils/datetime.h
+++ b/src/include/utils/datetime.h
@@ -276,7 +276,7 @@ extern void GetCurrentTimeUsec(struct pg_tm * tm, fsec_t *fsec, int *tzp);
 extern void j2date(int jd, int *year, int *month, int *day);
 extern int	date2j(int year, int month, int day);
 
-extern int ParseDateTime(const char *timestr, char *lowstr,
+extern int ParseDateTime(const char *timestr, char *workbuf, size_t buflen,
 			  char **field, int *ftype,
 			  int maxfields, int *numfields);
 extern int DecodeDateTime(char **field, int *ftype,
diff --git a/src/include/utils/guc.h b/src/include/utils/guc.h
index b679bc5..2ae69eb 100644
--- a/src/include/utils/guc.h
+++ b/src/include/utils/guc.h
@@ -149,6 +149,8 @@ extern void DefineCustomIntVariable(
 						const char *short_desc,
 						const char *long_desc,
 						int *valueAddr,
+						int minValue,
+						int maxValue,
 						GucContext context,
 						GucIntAssignHook assign_hook,
 						GucShowHook show_hook);
@@ -158,6 +160,8 @@ extern void DefineCustomRealVariable(
 						 const char *short_desc,
 						 const char *long_desc,
 						 double *valueAddr,
+						 double minValue,
+						 double maxValue,
 						 GucContext context,
 						 GucRealAssignHook assign_hook,
 						 GucShowHook show_hook);
diff --git a/src/include/utils/portal.h b/src/include/utils/portal.h
index 48cfa0d..a5c5477 100644
--- a/src/include/utils/portal.h
+++ b/src/include/utils/portal.h
@@ -182,6 +182,7 @@ typedef struct PortalData
 
 /* Prototypes for functions in utils/mmgr/portalmem.c */
 extern void EnablePortalManager(void);
+extern bool CommitHoldablePortals(void);
 extern void AtCommit_Portals(void);
 extern void AtAbort_Portals(void);
 extern void AtCleanup_Portals(void);
diff --git a/src/interfaces/ecpg/ChangeLog b/src/interfaces/ecpg/ChangeLog
index 1f82527..3e04df8 100644
--- a/src/interfaces/ecpg/ChangeLog
+++ b/src/interfaces/ecpg/ChangeLog
@@ -1895,3 +1895,8 @@ Mon Jan 10 13:55:32 CET 2005
 	- Set compat library version to 1.2.
 	- Set ecpg library version to 4.2.
 
+Tue Jan 25 13:47:45 CET 2005
+
+	- Fixed segfault in preprocessor due to free a struct twice.
+	- Set ecpg version to 3.2.1.
+
diff --git a/src/interfaces/ecpg/compatlib/Makefile b/src/interfaces/ecpg/compatlib/Makefile
index abb0b27..b2d2881 100644
--- a/src/interfaces/ecpg/compatlib/Makefile
+++ b/src/interfaces/ecpg/compatlib/Makefile
@@ -13,8 +13,8 @@ top_builddir = ../../../..
 include $(top_builddir)/src/Makefile.global
 
 NAME= ecpg_compat
-SO_MAJOR_VERSION= 1
-SO_MINOR_VERSION= 1
+SO_MAJOR_VERSION= 2
+SO_MINOR_VERSION= 0
 DLTYPE= library
 
 override CPPFLAGS := -I$(top_srcdir)/src/interfaces/ecpg/include -I$(libpq_srcdir) \
diff --git a/src/interfaces/ecpg/ecpglib/Makefile b/src/interfaces/ecpg/ecpglib/Makefile
index e4a5e75..70c2dfa 100644
--- a/src/interfaces/ecpg/ecpglib/Makefile
+++ b/src/interfaces/ecpg/ecpglib/Makefile
@@ -13,8 +13,8 @@ top_builddir = ../../../..
 include $(top_builddir)/src/Makefile.global
 
 NAME= ecpg
-SO_MAJOR_VERSION= 4
-SO_MINOR_VERSION= 2
+SO_MAJOR_VERSION= 5
+SO_MINOR_VERSION= 0
 DLTYPE= library
 
 override CPPFLAGS := -DFRONTEND -I$(top_srcdir)/src/interfaces/ecpg/include \
@@ -30,6 +30,11 @@ OBJS= execute.o typename.o descriptor.o data.o error.o prepare.o memory.o \
 SHLIB_LINK = -L../pgtypeslib -lpgtypes $(libpq) \
 	$(filter -lintl -lssl -lcrypto -lkrb5 -lcrypt -lm, $(LIBS)) $(PTHREAD_LIBS)
 
+ifeq ($(PORTNAME), win32)
+# Link to shfolder.dll instead of shell32.dll
+SHLIB_LINK += -lshfolder
+endif
+
 all: all-lib
 
 # Shared library stuff
diff --git a/src/interfaces/ecpg/pgtypeslib/Makefile b/src/interfaces/ecpg/pgtypeslib/Makefile
index 8b01249..e42e696 100644
--- a/src/interfaces/ecpg/pgtypeslib/Makefile
+++ b/src/interfaces/ecpg/pgtypeslib/Makefile
@@ -13,8 +13,8 @@ top_builddir = ../../../..
 include $(top_builddir)/src/Makefile.global
 
 NAME= pgtypes
-SO_MAJOR_VERSION= 1
-SO_MINOR_VERSION= 2
+SO_MAJOR_VERSION= 2
+SO_MINOR_VERSION= 0
 DLTYPE= library
 
 override CPPFLAGS := -I$(top_srcdir)/src/interfaces/ecpg/include \
diff --git a/src/interfaces/ecpg/preproc/Makefile b/src/interfaces/ecpg/preproc/Makefile
index 066cc14..52ac074 100644
--- a/src/interfaces/ecpg/preproc/Makefile
+++ b/src/interfaces/ecpg/preproc/Makefile
@@ -13,9 +13,9 @@ subdir = src/interfaces/ecpg/preproc
 top_builddir = ../../../..
 include $(top_builddir)/src/Makefile.global
 
-MAJOR_VERSION=3
-MINOR_VERSION=2
-PATCHLEVEL=0
+MAJOR_VERSION= 4
+MINOR_VERSION= 0
+PATCHLEVEL=1
 
 override CPPFLAGS := -I$(srcdir)/../include -I$(srcdir) $(CPPFLAGS) \
 	-DMAJOR_VERSION=$(MAJOR_VERSION) \
diff --git a/src/interfaces/libpq/Makefile b/src/interfaces/libpq/Makefile
index 9443a21..5c84d1d 100644
--- a/src/interfaces/libpq/Makefile
+++ b/src/interfaces/libpq/Makefile
@@ -16,8 +16,8 @@ include $(top_builddir)/src/Makefile.global
 
 # shared library parameters
 NAME= pq
-SO_MAJOR_VERSION= 3
-SO_MINOR_VERSION= 2
+SO_MAJOR_VERSION= 4
+SO_MINOR_VERSION= 0
 DLTYPE= library
 
 override CPPFLAGS :=  -DFRONTEND -I$(srcdir) $(CPPFLAGS) -I$(top_builddir)/src/port
@@ -55,7 +55,7 @@ endif
 # matter.)
 SHLIB_LINK += $(filter -lcrypt -ldes -lkrb -lcom_err -lcrypto -lk5crypto -lkrb5 -lssl -lsocket -lnsl -lresolv -lintl, $(LIBS)) $(PTHREAD_LIBS)
 ifeq ($(PORTNAME), win32)
-SHLIB_LINK += -lwsock32 -lws2_32 -lshell32 $(filter -leay32 -lssleay32, $(LIBS))
+SHLIB_LINK += -lshfolder -lwsock32 -lws2_32 $(filter -leay32 -lssleay32 -lcomerr32 -lkrb5_32, $(LIBS))
 endif
 
 
@@ -146,6 +146,7 @@ uninstall: uninstall-lib
 
 clean distclean: clean-lib
 	rm -f $(OBJS) crypt.c getaddrinfo.c inet_aton.c noblock.c pgstrcasecmp.c snprintf.c strerror.c open.c thread.c md5.c ip.c encnames.c wchar.c pthread.h
+	rm -f pg_config_paths.h	# Might be left over from a Win32 client-only build
 
 maintainer-clean: distclean
 	rm -f $(srcdir)/libpqdll.def $(srcdir)/libpqddll.def $(srcdir)/blibpqdll.def $(srcdir)/libpq.rc
diff --git a/src/interfaces/libpq/bcc32.mak b/src/interfaces/libpq/bcc32.mak
index 0d53d0c..8649998 100644
--- a/src/interfaces/libpq/bcc32.mak
+++ b/src/interfaces/libpq/bcc32.mak
@@ -4,7 +4,17 @@
 #        and a Win32 dynamic library libpq.dll with import library libpqdll.lib
 
 # Borland C++ base install directory goes here
-# BCB=d:\Borland\Bcc55
+# BCB=c:\Borland\Bcc55
+
+!IF "$(BCB)" == ""
+!MESSAGE You must edit bcc32.mak and define BCB at the top
+!ERROR misssing BCB
+!ENDIF
+
+!IF "$(__NMAKE__)" == ""
+!MESSAGE You must use the -N compatibility flag, e.g. make -N -f bcc32.make
+!ERROR missing -N
+!ENDIF
 
 !MESSAGE Building the Win32 DLL and Static Library...
 !MESSAGE
@@ -22,7 +32,7 @@ CFG=Release
 !MESSAGE You can specify a configuration when running MAKE
 !MESSAGE by defining the macro CFG on the command line. For example:
 !MESSAGE
-!MESSAGE make  -DCFG=[Release | Debug] /f bcc32.mak
+!MESSAGE make -N -DCFG=[Release | Debug] -f bcc32.mak
 !MESSAGE
 !MESSAGE Possible choices for configuration are:
 !MESSAGE
@@ -42,15 +52,17 @@ NULL=nul
 DEBUG=1
 OUTDIR=.\Debug
 INTDIR=.\Debug
-!else
+!ELSE
 OUTDIR=.\Release
 INTDIR=.\Release
-!endif
+!ENDIF
+
+OUTFILENAME=blibpq
 
 USERDEFINES=FRONTEND;NDEBUG;WIN32;_WINDOWS;HAVE_VSNPRINTF;HAVE_STRDUP;
 
 CPP=bcc32.exe
-CPP_PROJ = -I$(BCB)\include;..\..\include -WD -c -D$(USERDEFINES) -tWM \
+CPP_PROJ = -I$(BCB)\include;..\..\include -n"$(INTDIR)" -WD -c -D$(USERDEFINES) -tWM \
 		-a8 -X -w-use -w-par -w-pia -w-csu -w-aus -w-ccc
 
 !IFDEF DEBUG
@@ -59,47 +71,15 @@ CPP_PROJ	= $(CPP_PROJ) -Od -r- -k -v -y -vi- -D_DEBUG
 CPP_PROJ	= $(CPP_PROJ) -O -Oi -OS -DNDEBUG
 !endif
 
-LIB32=tlib.exe
-LIB32_FLAGS= 
-LIB32_OBJS= \
-	"$(OUTDIR)\win32.obj" \
-	"$(INTDIR)\getaddrinfo.obj" \
-	"$(INTDIR)\thread.obj" \
-	"$(INTDIR)\inet_aton.obj" \
-	"$(INTDIR)\crypt.obj" \
-	"$(INTDIR)\noblock.obj" \
-	"$(INTDIR)\pgstrcasecmp.obj" \
-	"$(INTDIR)\md5.obj" \
-	"$(INTDIR)\ip.obj" \
-	"$(INTDIR)\fe-auth.obj" \
-	"$(INTDIR)\fe-protocol2.obj" \
-	"$(INTDIR)\fe-protocol3.obj" \
-	"$(INTDIR)\fe-connect.obj" \
-	"$(INTDIR)\fe-exec.obj" \
-	"$(INTDIR)\fe-lobj.obj" \
-	"$(INTDIR)\fe-misc.obj" \
-	"$(INTDIR)\fe-print.obj" \
-	"$(INTDIR)\fe-secure.obj" \
-	"$(INTDIR)\pqexpbuffer.obj" \
-	"$(INTDIR)\pqsignal.obj" \
-	"$(INTDIR)\wchar.obj" \
-	"$(INTDIR)\encnames.obj"
-
-
-RSC=brcc32.exe
-RSC_PROJ=-l 0x409 -i$(BCB)\include -fo"$(INTDIR)\libpq.res"
-
-LINK32=ilink32.exe
-LINK32_FLAGS = -Gn -L$(BCB)\lib;$(INTDIR); -x -Tpd -v
-LINK32_OBJS= "$(INTDIR)\libpqdll.obj"
-
-ALL: config "$(OUTDIR)" "$(OUTDIR)\blibpq.dll" "$(OUTDIR)\blibpq.lib"
+ALL : config "$(OUTDIR)" "$(OUTDIR)\blibpq.dll" "$(OUTDIR)\blibpq.lib"
 
 CLEAN :
 	-@erase "$(INTDIR)\getaddrinfo.obj"
+	-@erase "$(INTDIR)\pgstrcasecmp.obj"
 	-@erase "$(INTDIR)\thread.obj"
 	-@erase "$(INTDIR)\inet_aton.obj"
 	-@erase "$(INTDIR)\crypt.obj"
+	-@erase "$(INTDIR)\noblock.obj"
 	-@erase "$(INTDIR)\md5.obj"
 	-@erase "$(INTDIR)\ip.obj"
 	-@erase "$(INTDIR)\fe-auth.obj"
@@ -117,15 +97,43 @@ CLEAN :
 	-@erase "$(OUTDIR)\win32.obj"
 	-@erase "$(INTDIR)\wchar.obj"
 	-@erase "$(INTDIR)\encnames.obj"
-	-@erase "$(INTDIR)\noblock.obj"
-	-@erase "$(INTDIR)\pgstrcasecmp.obj"
+	-@erase "$(INTDIR)\pthread-win32.obj"
+	-@erase "$(OUTDIR)\$(OUTFILENAME).lib"
+	-@erase "$(OUTDIR)\$(OUTFILENAME)dll.lib"
 	-@erase "$(OUTDIR)\libpq.res"
-	-@erase "$(OUTDIR)\blibpq.lib"
-	-@erase "$(OUTDIR)\blibpqdll.lib"
-	-@erase "$(OUTDIR)\blibpq.dll"
-	-@erase "$(OUTDIR)\blibpq.tds"
+	-@erase "$(OUTDIR)\$(OUTFILENAME).dll"
+	-@erase "$(OUTDIR)\$(OUTFILENAME).tds"
 	-@erase "$(INTDIR)\pg_config_paths.h"
 
+
+LIB32=tlib.exe
+LIB32_FLAGS= 
+LIB32_OBJS= \
+	"$(INTDIR)\win32.obj" \
+	"$(INTDIR)\getaddrinfo.obj" \
+	"$(INTDIR)\pgstrcasecmp.obj" \
+	"$(INTDIR)\thread.obj" \
+	"$(INTDIR)\inet_aton.obj" \
+	"$(INTDIR)\crypt.obj" \
+	"$(INTDIR)\noblock.obj" \
+	"$(INTDIR)\md5.obj" \
+	"$(INTDIR)\ip.obj" \
+	"$(INTDIR)\fe-auth.obj" \
+	"$(INTDIR)\fe-protocol2.obj" \
+	"$(INTDIR)\fe-protocol3.obj" \
+	"$(INTDIR)\fe-connect.obj" \
+	"$(INTDIR)\fe-exec.obj" \
+	"$(INTDIR)\fe-lobj.obj" \
+	"$(INTDIR)\fe-misc.obj" \
+	"$(INTDIR)\fe-print.obj" \
+	"$(INTDIR)\fe-secure.obj" \
+	"$(INTDIR)\pqexpbuffer.obj" \
+	"$(INTDIR)\pqsignal.obj" \
+	"$(INTDIR)\wchar.obj" \
+	"$(INTDIR)\encnames.obj" \
+	"$(INTDIR)\pthread-win32.obj"
+
+
 config: ..\..\include\pg_config.h pthread.h pg_config_paths.h
 
 ..\..\include\pg_config.h: ..\..\include\pg_config.h.win32
@@ -134,32 +142,91 @@ config: ..\..\include\pg_config.h pthread.h pg_config_paths.h
 pthread.h: pthread.h.win32
 	copy pthread.h.win32 pthread.h
 
-pg_config_paths.h: win32.mak
-	echo #define SYSCONFDIR "" >pg_config_paths.h
+pg_config_paths.h: bcc32.mak
+	echo \#define SYSCONFDIR "" > pg_config_paths.h
 
 "$(OUTDIR)" :
 	@if not exist "$(OUTDIR)/$(NULL)" mkdir "$(OUTDIR)"
 
+RSC=brcc32.exe
+RSC_PROJ=-l 0x409 -i$(BCB)\include -fo"$(INTDIR)\libpq.res"
+
+LINK32=ilink32.exe
+LINK32_FLAGS = -Gn -L$(BCB)\lib;$(INTDIR); -x -Tpd -v
+LINK32_OBJS= "$(INTDIR)\libpqdll.obj"
+
+# @<< is a Response file, http://www.opussoftware.com/tutorial/TutMakefile.htm
+
 "$(OUTDIR)\blibpq.dll": "$(OUTDIR)\blibpq.lib" $(LINK32_OBJS) "$(INTDIR)\libpq.res" blibpqdll.def 
-	$(LINK32) @&&!
+	$(LINK32) @<<
 	$(LINK32_FLAGS) +
 	c0d32.obj $(LINK32_OBJS), +
 	$@,, +
 	"$(OUTDIR)\blibpq.lib" import32.lib cw32mti.lib, +
 	blibpqdll.def,"$(INTDIR)\libpq.res"
-!
+<<
 	implib -w "$(OUTDIR)\blibpqdll.lib" blibpqdll.def $@
 
 "$(INTDIR)\libpq.res" : "$(INTDIR)" libpq.rc
-    $(RSC) $(RSC_PROJ) libpq.rc
+	$(RSC) $(RSC_PROJ) libpq.rc
 
 "$(OUTDIR)\blibpq.lib": $(LIB32_OBJS)
-	$(LIB32) $@ @&&!
+	$(LIB32) $@ @<<
 +-"$(**: =" &^
 +-")"
-!
+<<
 
 
-.c.obj:
-	$(CPP) -o"$(INTDIR)\$&" $(CPP_PROJ) $<
+"$(INTDIR)\getaddrinfo.obj" : ..\..\port\getaddrinfo.c
+	$(CPP) @<<
+	$(CPP_PROJ) ..\..\port\getaddrinfo.c
+<<
 
+"$(INTDIR)\pgstrcasecmp.obj" : ..\..\port\pgstrcasecmp.c
+	$(CPP) @<<
+	$(CPP_PROJ) ..\..\port\pgstrcasecmp.c
+<<
+
+"$(INTDIR)\thread.obj" : ..\..\port\thread.c
+	$(CPP) @<<
+	$(CPP_PROJ) ..\..\port\thread.c
+<<
+
+"$(INTDIR)\inet_aton.obj" : ..\..\port\inet_aton.c
+	$(CPP) @<<
+	$(CPP_PROJ) ..\..\port\inet_aton.c
+<<
+
+"$(INTDIR)\crypt.obj" : ..\..\port\crypt.c
+	$(CPP) @<<
+	$(CPP_PROJ) ..\..\port\crypt.c
+<<
+
+"$(INTDIR)\noblock.obj" : ..\..\port\noblock.c
+	$(CPP) @<<
+	$(CPP_PROJ) ..\..\port\noblock.c
+<<
+
+"$(INTDIR)\md5.obj" : ..\..\backend\libpq\md5.c
+	$(CPP) @<<
+	$(CPP_PROJ) ..\..\backend\libpq\md5.c
+<<
+
+"$(INTDIR)\ip.obj" : ..\..\backend\libpq\ip.c
+	$(CPP) @<<
+	$(CPP_PROJ) ..\..\backend\libpq\ip.c
+<<
+
+"$(INTDIR)\wchar.obj" : ..\..\backend\utils\mb\wchar.c
+	$(CPP) @<<
+	$(CPP_PROJ) /I"." ..\..\backend\utils\mb\wchar.c
+<<
+
+
+"$(INTDIR)\encnames.obj" : ..\..\backend\utils\mb\encnames.c
+	$(CPP) @<<
+	$(CPP_PROJ) /I"." ..\..\backend\utils\mb\encnames.c
+<<
+
+.c.obj:
+	$(CPP) $(CPP_PROJ) $<
diff --git a/src/interfaces/libpq/pthread-win32.c b/src/interfaces/libpq/pthread-win32.c
index fb7e26b..a1eec0c 100644
--- a/src/interfaces/libpq/pthread-win32.c
+++ b/src/interfaces/libpq/pthread-win32.c
@@ -12,7 +12,7 @@
 
 
 #include <windows.h>
-#include <pthread.h>
+#include "pthread.h"
 
 HANDLE
 pthread_self()
diff --git a/src/interfaces/libpq/win32.mak b/src/interfaces/libpq/win32.mak
index 25a30f3..2838f3c 100644
--- a/src/interfaces/libpq/win32.mak
+++ b/src/interfaces/libpq/win32.mak
@@ -41,7 +41,7 @@ CPP_OBJS=.\Release/
 !ENDIF
 
 
-ALL : config "$(OUTDIR)\$(OUTFILENAME).lib" "$(OUTDIR)\$(OUTFILENAME).dll" 
+ALL : config "$(OUTDIR)\$(OUTFILENAME).lib" "$(OUTDIR)\$(OUTFILENAME).dll"
 
 CLEAN :
 	-@erase "$(INTDIR)\getaddrinfo.obj"
@@ -65,16 +65,16 @@ CLEAN :
 	-@erase "$(INTDIR)\pqsignal.obj"
 	-@erase "$(OUTDIR)\libpqdll.obj"
 	-@erase "$(OUTDIR)\win32.obj"
+	-@erase "$(INTDIR)\wchar.obj"
+	-@erase "$(INTDIR)\encnames.obj"
+	-@erase "$(INTDIR)\pthread-win32.obj"
 	-@erase "$(OUTDIR)\$(OUTFILENAME).lib"
-	-@erase "$(OUTDIR)\$(OUTFILENAME).dll"
+	-@erase "$(OUTDIR)\$(OUTFILENAME)dll.lib"
 	-@erase "$(OUTDIR)\libpq.res"
+	-@erase "$(OUTDIR)\$(OUTFILENAME).dll"
 	-@erase "*.pch"
 	-@erase "$(OUTDIR)\libpq.pch"
 	-@erase "$(OUTDIR)\$(OUTFILENAME)dll.exp"
-	-@erase "$(OUTDIR)\$(OUTFILENAME)dll.lib"
-	-@erase "$(INTDIR)\wchar.obj"
-	-@erase "$(INTDIR)\encnames.obj"
-	-@erase "$(INTDIR)\pthread-win32.obj"
 	-@erase "$(INTDIR)\pg_config_paths.h"
 
 
@@ -138,7 +138,7 @@ LIB32_OBJS= \
 RSC_PROJ=/l 0x409 /fo"$(INTDIR)\libpq.res"
 
 LINK32=link.exe
-LINK32_FLAGS=kernel32.lib user32.lib advapi32.lib shell32.lib wsock32.lib $(SSL_LIBS)  \
+LINK32_FLAGS=kernel32.lib user32.lib advapi32.lib shfolder.lib wsock32.lib $(SSL_LIBS)  \
  /nologo /subsystem:windows /dll $(LOPT) /incremental:no\
  /pdb:"$(OUTDIR)\libpqdll.pdb" /machine:I386 /out:"$(OUTDIR)\$(OUTFILENAME).dll"\
  /implib:"$(OUTDIR)\$(OUTFILENAME)dll.lib"  /def:$(OUTFILENAME)dll.def
diff --git a/src/pl/plpython/plpython_test.sql b/src/pl/plpython/plpython_test.sql
index c78b4aa..17d6b2e 100644
--- a/src/pl/plpython/plpython_test.sql
+++ b/src/pl/plpython/plpython_test.sql
@@ -61,3 +61,10 @@ SELECT join_sequences(sequences) FROM sequences
 -- error in trigger
 --
 
+--
+-- Check Universal Newline Support
+--
+
+SELECT newline_lf();
+SELECT newline_cr();
+SELECT newline_crlf();
diff --git a/src/pl/plpython/test.sh b/src/pl/plpython/test.sh
index 5cc677c..facf29e 100755
--- a/src/pl/plpython/test.sh
+++ b/src/pl/plpython/test.sh
@@ -4,15 +4,24 @@ DBNAME=pltest
 
 echo -n "*** Destroy $DBNAME."
 dropdb $DBNAME > test.log 2>&1
+# drop failure is ok...
 echo " Done. ***"
 
 echo -n "*** Create $DBNAME."
-createdb $DBNAME >> test.log 2>&1
-echo " Done. ***"
+if createdb $DBNAME >> test.log 2>&1 ; then
+  echo " Done. ***"
+else
+  echo " Failed!  See test.log. ***"
+  exit 1
+fi
 
 echo -n "*** Create plpython."
-createlang plpythonu $DBNAME >> test.log 2>&1
-echo " Done. ***"
+if createlang plpythonu $DBNAME >> test.log 2>&1 ; then
+  echo " Done. ***"
+else
+  echo " Failed!  See test.log. ***"
+  exit 1
+fi
 
 echo -n "*** Create tables"
 psql -q $DBNAME < plpython_schema.sql >> test.log 2>&1
diff --git a/src/port/copydir.c b/src/port/copydir.c
index 0f833e5..6040657 100644
--- a/src/port/copydir.c
+++ b/src/port/copydir.c
@@ -56,6 +56,7 @@ copydir(char *fromdir, char *todir)
 		return -1;
 	}
 
+	errno = 0;
 	while ((xlde = readdir(xldir)) != NULL)
 	{
 		snprintf(fromfl, MAXPGPATH, "%s/%s", fromdir, xlde->d_name);
@@ -68,6 +69,24 @@ copydir(char *fromdir, char *todir)
 			FreeDir(xldir);
 			return -1;
 		}
+		errno = 0;
+	}
+#ifdef WIN32
+
+	/*
+	 * This fix is in mingw cvs (runtime/mingwex/dirent.c rev 1.4), but
+	 * not in released version
+	 */
+	if (GetLastError() == ERROR_NO_MORE_FILES)
+		errno = 0;
+#endif
+	if (errno)
+	{
+		ereport(WARNING,
+				(errcode_for_file_access(),
+				 errmsg("could not read directory \"%s\": %m", fromdir)));
+		FreeDir(xldir);
+		return -1;
 	}
 
 	FreeDir(xldir);
diff --git a/src/port/crypt.c b/src/port/crypt.c
index fa54cb9..7d0f14a 100644
--- a/src/port/crypt.c
+++ b/src/port/crypt.c
@@ -1,4 +1,4 @@
-/*	$NetBSD$	*/
+/*	$NetBSD: crypt.c,v 1.18 2001/03/01 14:37:35 wiz Exp $	*/
 
 /*
  * Copyright (c) 1989, 1993
@@ -37,7 +37,7 @@
 static char sccsid[] = "@(#)crypt.c	8.1.1.1 (Berkeley) 8/18/93";
 
 #else
-__RCSID("$NetBSD$");
+__RCSID("$NetBSD: crypt.c,v 1.18 2001/03/01 14:37:35 wiz Exp $");
 #endif
 #endif   /* not lint */
 
diff --git a/src/port/noblock.c b/src/port/noblock.c
index aa88727..f51079b 100644
--- a/src/port/noblock.c
+++ b/src/port/noblock.c
@@ -18,7 +18,7 @@
 #include <fcntl.h>
 
 bool
-set_noblock(int sock)
+pg_set_noblock(int sock)
 {
 #if !defined(WIN32) && !defined(__BEOS__)
 	return (fcntl(sock, F_SETFL, O_NONBLOCK) != -1);
@@ -34,3 +34,26 @@ set_noblock(int sock)
 #endif
 #endif
 }
+
+
+bool
+pg_set_block(int sock)
+{
+#if !defined(WIN32) && !defined(__BEOS__)
+	int flags;
+	flags = fcntl(sock, F_GETFL);
+	if (flags < 0 || fcntl(sock, F_SETFL, (long) (flags & ~O_NONBLOCK)))
+		return false;
+	return true;
+#else
+	long		ioctlsocket_ret = 0;
+
+	/* Returns non-0 on failure, while fcntl() returns -1 on failure */
+#ifdef WIN32
+	return (ioctlsocket(sock, FIONBIO, &ioctlsocket_ret) == 0);
+#endif
+#ifdef __BEOS__
+	return (ioctl(sock, FIONBIO, &ioctlsocket_ret) == 0);
+#endif
+#endif
+}
diff --git a/src/port/open.c b/src/port/open.c
index 68894dd..6fd9ab1 100644
--- a/src/port/open.c
+++ b/src/port/open.c
@@ -13,6 +13,7 @@
 
 #ifdef WIN32
 
+#include <postgres.h>
 #include <windows.h>
 #include <fcntl.h>
 #include <errno.h>
@@ -62,7 +63,7 @@ win32_open(const char *fileName, int fileFlags,...)
 	/* Check that we can handle the request */
 	assert((fileFlags & ((O_RDONLY | O_WRONLY | O_RDWR) | O_APPEND |
 						 (O_RANDOM | O_SEQUENTIAL | O_TEMPORARY) |
-						 _O_SHORT_LIVED |
+						 _O_SHORT_LIVED | O_DSYNC |
 	  (O_CREAT | O_TRUNC | O_EXCL) | (O_TEXT | O_BINARY))) == fileFlags);
 
 	sa.nLength = sizeof(sa);
@@ -81,7 +82,8 @@ win32_open(const char *fileName, int fileFlags,...)
 				 ((fileFlags & O_RANDOM) ? FILE_FLAG_RANDOM_ACCESS : 0) |
 		   ((fileFlags & O_SEQUENTIAL) ? FILE_FLAG_SEQUENTIAL_SCAN : 0) |
 		  ((fileFlags & _O_SHORT_LIVED) ? FILE_ATTRIBUTE_TEMPORARY : 0) |
-			 ((fileFlags & O_TEMPORARY) ? FILE_FLAG_DELETE_ON_CLOSE : 0),
+			 ((fileFlags & O_TEMPORARY) ? FILE_FLAG_DELETE_ON_CLOSE : 0)|
+					((fileFlags & O_DSYNC) ? FILE_FLAG_WRITE_THROUGH : 0),
 						NULL)) == INVALID_HANDLE_VALUE)
 	{
 		switch (GetLastError())
diff --git a/src/port/qsort.c b/src/port/qsort.c
index 3b6b2ca..9fc1458 100644
--- a/src/port/qsort.c
+++ b/src/port/qsort.c
@@ -6,7 +6,7 @@
  *	$PostgreSQL$
  */
 
-/*	$NetBSD$	*/
+/*	$NetBSD: qsort.c,v 1.13 2003/08/07 16:43:42 agc Exp $	*/
 
 /*-
  * Copyright (c) 1992, 1993
diff --git a/src/test/examples/Makefile b/src/test/examples/Makefile
index 0326d42..b55405d 100644
--- a/src/test/examples/Makefile
+++ b/src/test/examples/Makefile
@@ -7,7 +7,7 @@ top_builddir = ../../..
 include $(top_builddir)/src/Makefile.global
 
 override CPPFLAGS := -I$(libpq_srcdir) $(CPPFLAGS)
-override LDLIBS := $(libpq) -lpgport $(LDLIBS)
+override LDLIBS := $(libpq_pgport) $(LDLIBS)
 
 
 PROGS = testlibpq testlibpq2 testlibpq3 testlibpq4 testlo
diff --git a/src/test/regress/sql/case.sql b/src/test/regress/sql/case.sql
index 85e17e0..2ab22fb 100644
--- a/src/test/regress/sql/case.sql
+++ b/src/test/regress/sql/case.sql
@@ -58,6 +58,14 @@ SELECT '6' AS "One",
     ELSE 7
   END AS "Two WHEN with default";
 
+-- Constant-expression folding shouldn't evaluate unreachable subexpressions
+SELECT CASE WHEN 1=0 THEN 1/0 WHEN 1=1 THEN 1 ELSE 2/0 END;
+SELECT CASE 1 WHEN 0 THEN 1/0 WHEN 1 THEN 1 ELSE 2/0 END;
+
+-- However we do not currently suppress folding of potentially
+-- reachable subexpressions
+SELECT CASE WHEN i > 100 THEN 1/0 ELSE 0 END FROM case_tbl;
+
 -- Test for cases involving untyped literals in test expression
 SELECT CASE 'a' WHEN 'a' THEN 1 ELSE 2 END;
 
diff --git a/src/test/regress/sql/copy2.sql b/src/test/regress/sql/copy2.sql
index 70c8ea6..eb1a69c 100644
--- a/src/test/regress/sql/copy2.sql
+++ b/src/test/regress/sql/copy2.sql
@@ -4,7 +4,7 @@ CREATE TABLE x (
 	c text not null default 'stuff',
 	d text,
 	e text
-);
+) WITH OIDS;
 
 CREATE FUNCTION fn_x_before () RETURNS TRIGGER AS '
   BEGIN
@@ -129,6 +129,17 @@ COPY y TO stdout WITH CSV;
 COPY y TO stdout WITH CSV QUOTE '''' DELIMITER '|';
 COPY y TO stdout WITH CSV FORCE QUOTE col2 ESCAPE '\\';
 
+--test that we read consecutive LFs properly
+
+CREATE TEMP TABLE testnl (a int, b text, c int);
+
+COPY testnl FROM stdin CSV;
+1,"a field with two LFs
+
+inside",2
+\.
+
+
 DROP TABLE x, y;
 DROP FUNCTION fn_x_before();
 DROP FUNCTION fn_x_after();
diff --git a/src/test/regress/sql/create_table.sql b/src/test/regress/sql/create_table.sql
index b6a0a8f..b5a2889 100644
--- a/src/test/regress/sql/create_table.sql
+++ b/src/test/regress/sql/create_table.sql
@@ -51,7 +51,7 @@ CREATE TABLE tenk1 (
 	stringu1	name,
 	stringu2	name,
 	string4		name
-);
+) WITH OIDS;
 
 CREATE TABLE tenk2 (
 	unique1 	int4,
@@ -83,7 +83,7 @@ CREATE TABLE person (
 CREATE TABLE emp (
 	salary 		int4,
 	manager 	name
-) INHERITS (person);
+) INHERITS (person) WITH OIDS;
 
 
 CREATE TABLE student (
diff --git a/src/test/regress/sql/errors.sql b/src/test/regress/sql/errors.sql
index 630e490..5ccd13b 100644
--- a/src/test/regress/sql/errors.sql
+++ b/src/test/regress/sql/errors.sql
@@ -10,9 +10,6 @@ select 1;
 -- UNSUPPORTED STUFF
  
 -- doesn't work 
--- attachas nonesuch
---
--- doesn't work 
 -- notify pg_class
 --
 
diff --git a/src/test/regress/sql/portals.sql b/src/test/regress/sql/portals.sql
index c7e29c3..da4e3b0 100644
--- a/src/test/regress/sql/portals.sql
+++ b/src/test/regress/sql/portals.sql
@@ -235,3 +235,46 @@ SELECT declares_cursor('AB%');
 FETCH ALL FROM c;
 
 ROLLBACK;
+
+--
+-- Test behavior of both volatile and stable functions inside a cursor;
+-- in particular we want to see what happens during commit of a holdable
+-- cursor
+--
+
+create temp table tt1(f1 int);
+
+create function count_tt1_v() returns int8 as
+'select count(*) from tt1' language sql volatile;
+
+create function count_tt1_s() returns int8 as
+'select count(*) from tt1' language sql stable;
+
+begin;
+
+insert into tt1 values(1);
+
+declare c1 cursor for select count_tt1_v(), count_tt1_s();
+
+insert into tt1 values(2);
+
+fetch all from c1;
+
+rollback;
+
+begin;
+
+insert into tt1 values(1);
+
+declare c2 cursor with hold for select count_tt1_v(), count_tt1_s();
+
+insert into tt1 values(2);
+
+commit;
+
+delete from tt1;
+
+fetch all from c2;
+
+drop function count_tt1_v();
+drop function count_tt1_s();
diff --git a/src/test/regress/sql/rules.sql b/src/test/regress/sql/rules.sql
index 4651090..cd0ae43 100644
--- a/src/test/regress/sql/rules.sql
+++ b/src/test/regress/sql/rules.sql
@@ -679,7 +679,7 @@ SELECT * FROM shoelace_log ORDER BY sl_name;
 insert into shoelace values ('sl9', 0, 'pink', 35.0, 'inch', 0.0);
 insert into shoelace values ('sl10', 1000, 'magenta', 40.0, 'inch', 0.0);
 
-SELECT * FROM shoelace_obsolete;
+SELECT * FROM shoelace_obsolete ORDER BY sl_len_cm;
 SELECT * FROM shoelace_candelete;
 
 DELETE FROM shoelace WHERE EXISTS
